CREATE table module_kav_groups (
	id INT UNSIGNED AUTO_INCREMENT PRIMARY KEY
,	mn_id INT UNSIGNED NOT NULL DEFAULT 0
,	name VARCHAR(255) CHARACTER SET utf8 NOT NULL
,	settings TEXT CHARACTER SET utf8
) TYPE=INNODB;

CREATE TABLE module_kav_parameters (
	param VARCHAR(255) NOT NULL PRIMARY KEY
,	val VARCHAR(255)
) TYPE=INNODB;

CREATE TABLE module_kav_mailnames (
	mn_id INT UNSIGNED NOT NULL
,	in_group enum('off','default','on') NOT NULL DEFAULT 'default'
,	out_group enum('off','default','on') NOT NULL DEFAULT 'default'
,	PRIMARY KEY (mn_id)
) TYPE=INNODB;

INSERT INTO module_kav_parameters VALUES ('config_file', '/etc/kav/5.5/kav4mailservers/kav4mailservers.conf');
INSERT INTO module_kav_parameters VALUES ('config_file_daemon', '/etc/kav/5.5/kav4mailservers/kavdaemon.conf');
INSERT INTO module_kav_parameters VALUES ('aveserver_pid', '/var/run/aveserver.pid');
INSERT INTO module_kav_parameters VALUES ('keepup2date_pid', '/var/run/keepup2date.pid');
INSERT INTO module_kav_parameters VALUES ('install_dir', '/opt/kav/5.5/kav4mailservers/');
INSERT INTO module_kav_parameters VALUES ('allow_custom_settings', 'yes');
INSERT INTO module_kav_parameters VALUES ('server_scan_direction', 'none');
INSERT INTO module_kav_parameters VALUES ('update_interval', 'disabled');

INSERT INTO module_kav_groups VALUES ('1', '0', 'server_default', 'Check=yes
	Recipients=
	Senders=
	Quarantine=no
	QuarantinePath=/var/db/Quarantine
	FilterByName=
	FilteredQuarantine=yes
	AdminAddress=
	AddXHeaders=yes
	AdminNotify=yes
	AdminAction=unchanged
	SenderNotify=no
	RecipientNotify=yes
	RecipientAttachReport=yes
	RecipientAction=remove
	CuredAdminAction=cured
	CuredRecipientAction=cured
	ProtectedRecipientAction=unchanged');

